from dios import *
import pytest

s1 = pd.Series(range(10), index=range(10))
s2 = pd.Series(range(5, 10), index=range(5, 10))
s3 = pd.Series(range(1, 30, 2), index=range(1, 30, 2))
s4 = pd.Series(np.linspace(7, 13, 9), index=range(3, 12))
s1.name, s2.name, s3.name, s4.name = 'a', 'b', 'c', 'd'
d1 = DictOfSeries(data=dict(a=s1.copy(), b=s2.copy(), c=s3.copy(), d=s4.copy()))


@pytest.mark.parametrize(('idxer', 'exp'), [('a', s1), ('c', s3)])
def test__getitem_single(idxer, exp):
    a = d1[idxer]
    assert isinstance(a, pd.Series)
    assert (a == exp).all()


@pytest.mark.parametrize(('idxer', 'exp'), [('a', s1), ('c', s3)])
def test__getitem_single_loc(idxer, exp):
    a = d1.loc[:, idxer]
    assert isinstance(a, DictOfSeries)
    exp = DictOfSeries(data={idxer: exp})
    assert (a == exp).all().all()


@pytest.mark.parametrize(('idxer', 'exp'), [(0, s1), (1, s2), (2, s3), (3, s4),
                                            (-1, s4), (-2, s3), (-3, s2), (-4, s1)])
def test__getitem_single_iloc(idxer, exp):
    a = d1.iloc[:, idxer]
    assert isinstance(a, DictOfSeries)
    exp = DictOfSeries(data={exp.name: exp})
    assert (a == exp).all().all()


@pytest.mark.parametrize('idxer', ['x', '1', 1, None, ])
def test__getitem_single_fail(idxer):
    with pytest.raises(KeyError):
        a = d1[idxer]


@pytest.mark.parametrize('idxer', ['x', '1', 1, None, ])
def test__getitem_single_loc_fail(idxer):
    with pytest.raises(KeyError):
        a = d1.loc[:, idxer]


@pytest.mark.parametrize('idxer', [-5, 99, 'a', '2', ])
def test__getitem_single_iloc_fail(idxer):
    with pytest.raises(KeyError):
        a = d1.iloc[:, idxer]



BLIST = [True, False, False, True]
BOOLIDXER = [BLIST, pd.Series(BLIST), d1.copy() > 10]
INDEXERS = [['a'], ['a', 'c'], pd.Series(['a', 'c'])] + BOOLIDXER


@pytest.mark.parametrize('idxer', INDEXERS)
def test__getitem__(idxer):
    print()
    print(d1.values)

    d = d1[idxer]
    assert isinstance(d, DictOfSeries)

#     return
#     d = d1[['a', 'b']]
#     assert isinstance(d, DictOfSeries)
#     a = d['a']
#     b = d['b']
#     assert (a == s1).all()
#     assert (b == s2).all()
#
#     l, r = 1, 7
#     d = d1[l:r]
#     assert isinstance(d, DictOfSeries)
#     for s in [s1, s2, s3, s4]:
#         exp = s[l:r]
#         assert (d[s.name] == exp).all()
#
#     d = d1.loc[l:r]
#     assert isinstance(d, DictOfSeries)
#     for s in [s1, s2, s3, s4]:
#         exp = s.loc[l:r]
#         assert (d[s.name] == exp).all()
#
#     d = d1.iloc[l:r]
#     assert isinstance(d, DictOfSeries)
#     for s in [s1, s2, s3, s4]:
#         exp = s.iloc[l:r]
#         assert (d[s.name] == exp).all()
#
#
# if __name__ == '__main__':
#     for i in INDEXERS:
#         test__geting_items(i)
